"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Akrantiain = void 0;
var _1 = require(".");
var parsers_1 = require("../parser/parsers");
var Akrantiain = (function () {
    function Akrantiain(modules) {
        this.explicitModules = [];
        var _loop_1 = function (module_1) {
            if (module_1.name === null) {
                if (this_1.implicitModule === undefined) {
                    this_1.implicitModule = module_1;
                }
                else {
                    throw new _1.AkrantiainError(1003, -1, "There are more than one implicit modules");
                }
            }
            else {
                var duplicated = this_1.explicitModules.findIndex(function (existingModule) { return existingModule.name.equals(module_1.name); }) >= 0;
                if (!duplicated) {
                    this_1.explicitModules.push(module_1);
                }
                else {
                    throw new _1.AkrantiainError(1004, 1113, "Duplicate definition of module: '" + module_1.name + "'");
                }
            }
        };
        var this_1 = this;
        for (var _i = 0, modules_1 = modules; _i < modules_1.length; _i++) {
            var module_1 = modules_1[_i];
            _loop_1(module_1);
        }
        if (this.implicitModule === undefined) {
            throw new _1.AkrantiainError(1002, -1, "No implicit module");
        }
        this.checkUnknownModuleName();
        this.checkCircularModuleName();
    }
    Akrantiain.load = function (source) {
        var akrantiain = parsers_1.Parsers.akrantiain.tryParse(source);
        return akrantiain;
    };
    Akrantiain.prototype.convert = function (input) {
        if (this.implicitModule !== undefined) {
            return this.implicitModule.convert(input, this);
        }
        else {
            throw new _1.AkrantiainError(9003, -1, "Cannot happen (at Akrantiain#convert)");
        }
    };
    Akrantiain.prototype.checkUnknownModuleName = function () {
        var modules = __spreadArrays(this.explicitModules, [this.implicitModule]);
        for (var _i = 0, modules_2 = modules; _i < modules_2.length; _i++) {
            var module_2 = modules_2[_i];
            var name_1 = module_2.findUnknownModuleName(this);
            if (name_1 !== undefined) {
                throw new _1.AkrantiainError(1000, 1111, "No such module: '" + name_1 + "'");
            }
        }
    };
    Akrantiain.prototype.checkCircularModuleName = function () {
        var name = this.implicitModule.findCircularModuleName([], this);
        if (name !== undefined) {
            throw new _1.AkrantiainError(1001, 1112, "Circular reference involving module: '" + name + "'");
        }
    };
    Akrantiain.prototype.findModule = function (name) {
        for (var _i = 0, _a = this.explicitModules; _i < _a.length; _i++) {
            var module_3 = _a[_i];
            if (module_3.name !== null && module_3.name.equals(name)) {
                return module_3;
            }
        }
        return undefined;
    };
    Akrantiain.prototype.toString = function (indent) {
        if (indent === void 0) { indent = 0; }
        var string = "";
        if (this.implicitModule !== undefined) {
            string += this.implicitModule.toString(indent);
        }
        for (var _i = 0, _a = this.explicitModules; _i < _a.length; _i++) {
            var module_4 = _a[_i];
            string += module_4.toString(indent);
        }
        return string;
    };
    return Akrantiain;
}());
exports.Akrantiain = Akrantiain;
