"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Environment = void 0;
var _1 = require(".");
var Environment = (function () {
    function Environment(rawName) {
        var upperRawName = rawName.toUpperCase();
        if (upperRawName === "CASE_SENSITIVE") {
            this.name = "CASE_SENSITIVE";
        }
        else if (upperRawName === "PRESERVE_CASE") {
            this.name = "PRESERVE_CASE";
        }
        else if (upperRawName.match(/^FALL_?(THROUGH|THRU)$/)) {
            this.name = "FALL_THROUGH";
        }
        else if (upperRawName === "USE_NFD") {
            this.name = "USE_NFD";
        }
        else {
            var caution = new _1.AkrantiainError(3000, 2435, "Invalid environment name: '" + rawName + "'");
            console.warn(caution.message);
        }
    }
    Environment.prototype.toString = function () {
        var string = "";
        if (this.name !== undefined) {
            string += "@" + this.name + ";";
        }
        else {
            string += "@<undefined>;";
        }
        return string;
    };
    return Environment;
}());
exports.Environment = Environment;
