"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Identifier = void 0;
var _1 = require(".");
var Identifier = (function () {
    function Identifier(text) {
        this.text = text;
    }
    Identifier.prototype.matchRight = function (stat, from, module) {
        var content = module.findContent(this);
        if (content !== undefined) {
            var to = content.matchRight(stat, from, module);
            return to;
        }
        else {
            throw new _1.AkrantiainError(9000, -1, "Cannot happen (at Identifier#matchRight)");
        }
    };
    Identifier.prototype.matchLeft = function (stat, to, module) {
        var content = module.findContent(this);
        if (content !== undefined) {
            var from = content.matchLeft(stat, to, module);
            return from;
        }
        else {
            throw new _1.AkrantiainError(9001, -1, "Cannot happen (at Identifier#matchLeft)");
        }
    };
    Identifier.prototype.isConcrete = function () {
        return true;
    };
    Identifier.prototype.findUnknownIdentifier = function (module) {
        if (!module.hasDefinition(this)) {
            return this;
        }
        else {
            return undefined;
        }
    };
    Identifier.prototype.findCircularIdentifier = function (identifiers, module) {
        var _this = this;
        var identifier = identifiers.find(function (identifier) { return identifier.equals(_this); });
        if (identifier !== undefined) {
            return identifier;
        }
        else {
            var definition = module.findDefinition(this);
            if (definition !== undefined) {
                return definition.findCircularIdentifier(identifiers, module);
            }
            else {
                return undefined;
            }
        }
    };
    Identifier.prototype.equals = function (that) {
        return this.text === that.text;
    };
    Identifier.prototype.toString = function () {
        return this.text;
    };
    return Identifier;
}());
exports.Identifier = Identifier;
