"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModuleChain = exports.ModuleName = void 0;
var ModuleName = (function () {
    function ModuleName(text, extraText) {
        if (extraText !== undefined) {
            this.text = [text, extraText];
        }
        else {
            this.text = text;
        }
    }
    ModuleName.prototype.equals = function (that) {
        if (typeof this.text === "string" && typeof that.text === "string") {
            return this.text === that.text;
        }
        else if (Array.isArray(this.text) && Array.isArray(that.text)) {
            return this.text[0] === that.text[0] && this.text[1] === that.text[1];
        }
        else {
            return false;
        }
    };
    ModuleName.prototype.toString = function () {
        var string = "";
        if (typeof this.text === "string") {
            string += this.text.toString();
        }
        else {
            string += this.text.join(" => ");
        }
        return string;
    };
    return ModuleName;
}());
exports.ModuleName = ModuleName;
var ModuleChain = (function () {
    function ModuleChain(names) {
        this.names = names;
    }
    ModuleChain.prototype.toString = function () {
        var string = "";
        string += "%% " + this.names.join(" >> ") + ";";
        return string;
    };
    return ModuleChain;
}());
exports.ModuleChain = ModuleChain;
