import { Akrantiain, Definition, Environment, EnvironmentName, Identifier, Matchable, ModuleChain, ModuleName, Rule } from ".";
export declare class Module {
    name: ModuleName | null;
    private definitions;
    private rules;
    private environments;
    private moduleChain?;
    constructor(name: ModuleName | null, sentences: Array<Sentence>);
    convert(input: string, akrantiain: Akrantiain): string;
    private convertByRule;
    private convertByModuleChain;
    private checkUnknownIdentifier;
    private checkCircularIdentifier;
    findUnknownModuleName(akrantiain: Akrantiain): ModuleName | undefined;
    findCircularModuleName(names: Array<ModuleName>, akrantiain: Akrantiain): ModuleName | undefined;
    findDefinition(identifier: Identifier): Definition | undefined;
    findContent(identifier: Identifier): Matchable | undefined;
    findPunctuationContent(): Matchable;
    hasDefinition(identifier: Identifier): boolean;
    hasEnvironment(name: EnvironmentName): boolean;
    toString(indent?: number): string;
}
export declare type Sentence = Definition | Rule | Environment | ModuleChain;
