import { Dollar, Identifier, Matchable, Module, Quote, Slash, Stat } from ".";
export declare class Rule {
    private selections;
    private leftCondition?;
    private rightCondition?;
    private phonemes;
    constructor(ruleLeft: RuleLeft, ruleRight: RuleRight);
    apply(stat: Stat, module: Module): Stat;
    private applyOnce;
    private applyOnceSelections;
    private testLeftCondition;
    private testRightCondition;
    private checkLength;
    private checkConcrete;
    private normalize;
    findUnknownIdentifier(module: Module): Identifier | undefined;
    toString(): string;
}
export declare type RuleLeft = {
    selections: Array<Matchable>;
    leftCondition?: Matchable;
    rightCondition?: Matchable;
};
export declare type RuleRight = Array<Phoneme>;
export declare type Phoneme = Quote | Slash | Dollar;
