"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StatElement = void 0;
var stat_1 = require("./stat");
var StatElement = (function () {
    function StatElement(part, result, columnNumber) {
        this.part = part;
        this.result = result;
        this.columnNumber = columnNumber;
    }
    StatElement.prototype.divide = function () {
        var elements = [];
        for (var _i = 0, _a = this.part; _i < _a.length; _i++) {
            var char = _a[_i];
            var element = new StatElement(char, null);
            elements.push(element);
        }
        return elements;
    };
    StatElement.prototype.isValid = function (module) {
        if (this.result === null) {
            if (this.part.match(/^\s*$/)) {
                return true;
            }
            else {
                var stat = new stat_1.Stat([this]);
                if (module.findPunctuationContent().matchRight(stat, 0, module) >= 0) {
                    return true;
                }
                else {
                    return false;
                }
            }
        }
        else {
            return true;
        }
    };
    StatElement.prototype.isConverted = function () {
        return this.result !== null;
    };
    return StatElement;
}());
exports.StatElement = StatElement;
