"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dollar = exports.Circumflex = void 0;
var Circumflex = (function () {
    function Circumflex() {
    }
    Circumflex.prototype.matchRight = function (stat, from, module) {
        var to = -1;
        var matched = false;
        var pointer = from;
        while (pointer <= stat.elements.length) {
            var element = stat.elements[pointer];
            if (element !== undefined) {
                var elementPart = element.part;
                var punctuationTo = -1;
                if (elementPart.match(/^\s*$/)) {
                    matched = true;
                    pointer++;
                }
                else if ((punctuationTo = module.findPunctuationContent().matchRight(stat, pointer, module)) >= 0) {
                    matched = true;
                    pointer = punctuationTo;
                }
                else {
                    if (matched || from === 0) {
                        to = pointer;
                    }
                    break;
                }
            }
            else {
                to = pointer;
                break;
            }
        }
        return to;
    };
    Circumflex.prototype.matchLeft = function (stat, to, module) {
        var from = -1;
        var matched = false;
        var pointer = to - 1;
        while (pointer >= -1) {
            var element = (pointer >= 0) ? stat.elements[pointer] : undefined;
            if (element !== undefined) {
                var elementPart = element.part;
                var punctuationFrom = -1;
                if (elementPart.match(/^\s*$/)) {
                    matched = true;
                    pointer--;
                }
                else if ((punctuationFrom = module.findPunctuationContent().matchLeft(stat, pointer, module)) >= 0) {
                    matched = true;
                    pointer = punctuationFrom;
                }
                else {
                    if (matched || to === stat.elements.length) {
                        from = pointer + 1;
                    }
                    break;
                }
            }
            else {
                from = pointer + 1;
                break;
            }
        }
        return from;
    };
    Circumflex.prototype.isConcrete = function () {
        return false;
    };
    Circumflex.prototype.findUnknownIdentifier = function (module) {
        return undefined;
    };
    Circumflex.prototype.findCircularIdentifier = function (identifiers, module) {
        return undefined;
    };
    Circumflex.prototype.toString = function () {
        return "^";
    };
    return Circumflex;
}());
exports.Circumflex = Circumflex;
var Dollar = (function () {
    function Dollar() {
    }
    Dollar.prototype.toString = function () {
        return "$";
    };
    return Dollar;
}());
exports.Dollar = Dollar;
