"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Slash = exports.Quote = void 0;
var Quote = (function () {
    function Quote(text) {
        this.text = text;
    }
    Quote.prototype.matchRight = function (stat, from, module) {
        var to = -1;
        var matchedLength = 0;
        var pointer = from;
        if (this.text !== "") {
            var text = (module.hasEnvironment("USE_NFD")) ? this.text.normalize("NFD") : this.text;
            while (pointer < stat.elements.length) {
                var element = stat.elements[pointer];
                var elementPart = element.part;
                if (matchedLength + elementPart.length <= text.length) {
                    var textSubstring = text.substring(matchedLength, matchedLength + elementPart.length);
                    var adjustedTextSubstring = textSubstring;
                    var adjustedElementPart = elementPart;
                    if (!module.hasEnvironment("CASE_SENSITIVE")) {
                        adjustedTextSubstring = adjustedTextSubstring.toLowerCase();
                    }
                    if (!module.hasEnvironment("CASE_SENSITIVE") && module.hasEnvironment("PRESERVE_CASE")) {
                        adjustedElementPart = adjustedElementPart.toLowerCase();
                    }
                    if (adjustedTextSubstring === adjustedElementPart) {
                        matchedLength += elementPart.length;
                        if (matchedLength === text.length) {
                            to = pointer + 1;
                            break;
                        }
                    }
                    else {
                        break;
                    }
                }
                else {
                    break;
                }
                pointer++;
            }
        }
        else {
            to = from;
        }
        return to;
    };
    Quote.prototype.matchLeft = function (stat, to, module) {
        var from = -1;
        var matchedLength = 0;
        var pointer = to - 1;
        if (this.text !== "") {
            var text = (module.hasEnvironment("USE_NFD")) ? this.text.normalize("NFD") : this.text;
            while (pointer >= 0) {
                var element = stat.elements[pointer];
                var elementPart = element.part;
                if (matchedLength + elementPart.length <= text.length) {
                    var textSubstring = text.substring(text.length - elementPart.length - matchedLength, text.length - matchedLength);
                    var adjustedTextSubstring = textSubstring;
                    var adjustedElementPart = elementPart;
                    if (!module.hasEnvironment("CASE_SENSITIVE")) {
                        adjustedTextSubstring = adjustedTextSubstring.toLowerCase();
                    }
                    if (!module.hasEnvironment("CASE_SENSITIVE") && module.hasEnvironment("PRESERVE_CASE")) {
                        adjustedElementPart = adjustedElementPart.toLowerCase();
                    }
                    if (adjustedTextSubstring === adjustedElementPart) {
                        matchedLength += elementPart.length;
                        if (matchedLength === text.length) {
                            from = pointer;
                            break;
                        }
                    }
                    else {
                        break;
                    }
                }
                else {
                    break;
                }
                pointer--;
            }
        }
        else {
            from = to;
        }
        return from;
    };
    Quote.prototype.isConcrete = function () {
        return true;
    };
    Quote.prototype.findUnknownIdentifier = function (module) {
        return undefined;
    };
    Quote.prototype.findCircularIdentifier = function (identifiers, module) {
        return undefined;
    };
    Quote.prototype.toString = function () {
        return "\"" + this.text + "\"";
    };
    return Quote;
}());
exports.Quote = Quote;
var Slash = (function () {
    function Slash(text) {
        this.text = text;
    }
    Slash.prototype.toString = function () {
        return "/" + this.text + "/";
    };
    return Slash;
}());
exports.Slash = Slash;
